/* getfqdn - get the fully qualified system hostname */
/* (c) 2013 SAS Institute, Inc. All rights reserved. */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <netdb.h>
#include <string.h>


int main( int argc,char **argv )
{
    char name[256];
    int namelen=256;
    int result;
    
    struct hostent *host;
    char *fqdn;
    int i;
    
    result=gethostname( name,namelen ); 
    if ( result!=0 ) {
        fprintf( stderr,"gethostname() failed: %s\n",strerror( errno ) );
        exit( 1 );
    }
    fprintf( stderr,"gethostname(): %s\n",name );
    
    if ( strchr( name,'.' )==NULL ) {
        fprintf( stderr,"hostname is not fully qualified, trying gethostbyname\n" );
        
        host=gethostbyname( name );
        if ( host==NULL ) {
            fprintf( stderr,"gethostbyname() failed. %s\n",strerror( errno ) );
            exit( 1 );
        }
        
        /* find an fqdn address to use */
        fqdn=host->h_name;
        if ( strchr( fqdn,'.' )==NULL ) {
            for ( i=0; host->h_aliases[i]!=NULL; i++ ) {
                if ( strchr( host->h_aliases[i],'.' )!=NULL ) {
                    fqdn=host->h_aliases[i];
                    break;
                }
            }
        }
        
        fprintf( stderr,"gethostbyname(): %s\n",fqdn );
    }
    
    exit( 0 );
}
